local shapes = require "HardonCollider.shapes"

collide = { }

collide.newImage = function(...)
	local imagenames = {...}
	assert(#imagenames>0, "Mindestens ein Bildname muss angegeben werden!")
	local idat = love.image.newImageData(imagenames[1])
	local w = idat:getWidth()
	local h = idat:getHeight()
	local xmin, xmax, ymin, ymax = w,0,h,0
	
	for x=0, w-1 do
		for y=0, h-1 do
			r,g,b,a=idat:getPixel(x,y)
			if a>254 then
				if x<xmin then xmin=x end
				if x>xmax then xmax=x end
				if y<ymin then ymin=y end
				if y>ymax then ymax=y end
			end
		end
	end

	local s = shapes.newPolygonShape(xmin,ymin, xmax,ymin, xmax,ymax, xmin,ymax)
	s.images = {}
	for i,v in ipairs(imagenames) do
		s.images[i] = love.graphics.newImage(v)
		assert(s.images[i]:getWidth()==w and s.images[i]:getHeight()==h, "Die Bilder müssen gleich gross wie das erste sein! " .. v)
	end
	s._x = xmin
	s._y = ymin
	s._h = ymax-ymin
	s._w = xmax-xmin
	local ii = 1
	function s:index(i)
		if (i~=nil and i>0 and i<=#self.images) then
			ii=i
		end
		return ii
	end
	function s:draw()
		local x,y = self:center()
		local r = self:rotation()
		love.graphics.draw(self.images[ii], x, y, r, 1,1, self._x+ math.floor(self._w/2), self._y + math.floor(self._h/2))
	end
	function s:clone()
		local c = shapes.newPolygonShape(self._x,self._y, self._w+self._x,self._y, self._w+self._x,self._h+self._y, self._x,self._h+self._y)
		c._x, c._y, c._h, c._w = self._x, self._y, self._h, self._w
		c.images = s.images
		c.draw = s.draw
		c.index = s.index
		c.clone = s.clone
		return c
	end
	return s
end

collide.newRectangle = function(w, h)
	local w = w/2
	local h = h/2
	local d = -0.5
	local s = shapes.newPolygonShape(-w+d,-h+d, w+d,-h+d, w+d,h+d, -w+d,h+d)
	return s
end
